import java.awt.Graphics;
import java.awt.event.MouseEvent;

/** 
 * This abstract class deals with some specific mouse actions performances.
 *
 * @author TerpPresent
 * @version 2.0 TerpPresent
 */

public interface CellHandle

{
  
  /** 
   * Calls overlay method on Graphics Object.
   * @param g A variable of type Graphics.
   * @see Graphics
   */    
  public abstract void paint(Graphics g);
  
  /** 
   * Fills a cell if the cell is null.
   * @param g A variable of type Graphics.
   * @see Graphics
   */    
  public abstract void overlay(Graphics g);
  
  /** 
   * A specific action when mouse moved is recognized.
   * @param mouseevent A variable of type MouseEvent.
   * @see MouseEvent
   */    
  public abstract void mouseMoved(MouseEvent mouseevent);
  
  /** 
   * A specific action when mouse pressed is recognized.
   * @param mouseevent A variable of type MouseEvent.
   * @see MouseEvent
   */    
  public abstract void mousePressed(MouseEvent mouseevent);
  
  /** 
   * A specific action when mouse dragged is recognized.
   * @param mouseevent A variable of type MouseEvent.
   * @see MouseEvent
   */    
  public abstract void mouseDragged(MouseEvent mouseevent);
  
  /** 
   * A specific action when mouse released is recognized.
   * @param mouseevent A variable of type MouseEvent.
   * @see MouseEvent
   */    
  public abstract void mouseReleased(MouseEvent mouseevent);
}