/** 
 * This class deals with cell mapping.
 *
 * Referenced class of package com.jgraph.graph is
 * CellView.
 *
 * @author TerpPresent
 * @version 2.0 TerpPresent
 */

public interface CellMapper

{
  
  /** 
   * Retrieves a mapping.
   * @param obj A variable of Object data type.
   * @param flag A variable of Onject data type.
   * @return A CellView data type
   * @see Object
   * @see CellView
   */    
  public abstract CellView getMapping(Object obj, boolean flag);
  
  /** 
   * Sets a mapping.
   * @param obj A variable of Object data type.
   * @param cellview A variable of CellView data type.
   * @see Object
   * @see CellView
   */    
  public abstract void putMapping(Object obj, CellView cellview);
}
