/** 
 * This class deals with the creation of a view and its sizing.
 * 
 * Referenced classes of package com.jgraph.graph are
 * CellMapper and CellView.
 *
 * @author TerpPresent
 * @version 2.0 TerpPresent
 */

public interface CellViewFactory

{
  
  /** 
   * Creates a view from an Object.
   * @param obj A variable of Object data type.
   * @param cellmapper A variable of CellMapper data type.
   * @return A CellView data type.
   * @see Object
   * @see CellMapper
   * @see CellView
   */    
  public abstract CellView createView(Object obj, CellMapper cellmapper);
  
  /**
   * Updates a CellView object by auto sizing.
   * @param cellview A variable of CellView data type.
   * @see CellView
   */    
  public abstract void updateAutoSize(CellView cellview);
}
