
import java.awt.Component;

/** 
 * This class deals with a cell view rendering.
 * 
 * Referenced class of package com.jgraph.graph is
 * CellView.
 *
 * @author TerpPresent
 * @version 2.0 TerpPresent
 */

public interface CellViewRenderer

{
  
  /**
   * Retrieves a rendered components from an object.
   * @param jgraph A variable of JGraph data type.
   * @param cellview A variable of CellView data type.
   * @param flag A variable of boolean data type.
   * @param flag1 A variable of boolean data type.
   * @param flag2 A variable of boolean data type.
   * @return A Component data type.
   * @see JGraph
   * @see CellView
   * @see Component
   */    
  public abstract Component getRendererComponent(JGraph jgraph, CellView cellview, boolean flag, boolean flag1, boolean flag2);
}
