
import java.awt.Component;
import javax.swing.*;

/**
 * The default editor for graph cells.
 *
 * Referenced class of package com.jgraph.graph is
 * GraphCellEditor.
 *
 * @author Gaudenz Alder
 * @version 1.0 1/1/02
 */
public class DefaultRealEditor extends DefaultCellEditor
  implements GraphCellEditor
{
  
  /**
   * Constructs a DefaultCellEditor that uses a text field.
   * @param jtextfield A variable of JTextField data type.
   * @see JTextField
   */
  public DefaultRealEditor(JTextField jtextfield)
  {
    super(jtextfield);
    setClickCountToStart(1);
  }
  
  /**
   * Constructs a DefaultCellEditor object that uses a check box.
   * @param jcheckbox A variable of JCheckBox data type.
   * @see JCheckBox
   */
  public DefaultRealEditor(JCheckBox jcheckbox)
  {
    super(jcheckbox);
  }
  
  /**
   * Constructs a DefaultCellEditor object that uses a combo box.
   * @param jcombobox A variable of JComboBox data type.
   * @see JComboBox
   */
  public DefaultRealEditor(JComboBox jcombobox)
  {
    super(jcombobox);
  }
  
  /** 
   * Gets the graph cell editor component and returns it
   * @param jgraph A variable of JGraph data type.
   * @param obj A variable of Object data type.
   * @param flag A variable of boolean data type.
   * @return A Component data type.
   * @see JGraph
   * @see Object
   * @see Component
   */
  public Component getGraphCellEditorComponent(JGraph jgraph, Object obj, boolean flag)
  {
    String s = jgraph.convertValueToString(obj);
    delegate.setValue(s);
    if(editorComponent instanceof JTextField)
    {
      ((JTextField)editorComponent).selectAll();
    }
    return editorComponent;
  }
}
