/*
 * @(#)EditCellAction.java 1.2 30.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;


/**
 * Action that starts editing the first selected cell.
 * 
 * @author sven.luzar
 * @version 2.0
 *
 */
public class EditCell extends AbstractActionDefault {

 /**
  * Constructor for EditCellAction.
  * @param graphpad This is a reference to the graphpad for this action, and
  * is sent to super().
  */
 public EditCell(GPGraphpad graphpad) {
  super(graphpad);
 }

 /** Performs an action on a selected cell.
  * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
  * @param e The action to be performed.
  */
 public void actionPerformed(ActionEvent e) {
  getCurrentGraph().startEditingAtCell(getCurrentGraph().getSelectionCell());
 }

}
