/*
 * @(#)EditCopy.java 1.2 02.02.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;

import java.awt.*;
import java.awt.image.*;
import java.awt.datatransfer.*;

/** Action that copies a selected cell.
 *
 * @author sven.luzar
 * @version 3.0 TerpPresent
 *
 */
public class EditCopy extends AbstractActionDefault implements ClipboardOwner
{
  /** A reference to a graphpad. */
  public static GPGraphpad mygp;
  
  public String name = "TerpPresent" ;
  
	public EditCopy (){}

  /**
   * Constructor for EditCopy.
   * @param graphpad This is a reference to the graphpad for this action, and is sent
   * to super().
   */
  public EditCopy(GPGraphpad graphpad) {
    super(graphpad);
    mygp = graphpad;
  }
  
  /** Handler for the copy action.
   * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
   * @param e The action to be performed.
   */
  public void actionPerformed(ActionEvent e) 
	{
    //TransferHandler.getCopyAction().actionPerformed(
    //		new ActionEvent(getCurrentGraph(), e.getID() , e.getActionCommand() ));
    
    Copy();
  }

  /** Copies the contents of the selected cells to the Clipboard  as a BufferedImage or as a string depending
   * on what cells have been selected.
   * 
   */ 
  public static void Copy()
  {
  	boolean stringFlavor = false ;
  	
    Object[] cells = mygp.getCurrentGraph().getSelectionCells();

    for (int i = 0; i <cells.length; i++)
    	if ( cells [i] instanceof TextCell)
    	{
    		mygp.clip_obj = new UMClipObj (((TextCell)cells[i]).getUserObject().toString(), "TerpPresent") ;
    		stringFlavor = true ;
    		break ;
    	}
    	
    if (!stringFlavor)
    {	
    	BufferedImage copy_image = (BufferedImage)(GPConverter.toImage(mygp.getCurrentGraph(), cells)) ;
    	mygp.clip_obj = new UMClipObj(copy_image, "TerpPresent");
    }
    
    try 
		{
      Toolkit.getDefaultToolkit().getSystemClipboard().setContents( mygp.clip_obj, new EditCopy ());
    }catch (Exception e){ }
  }
  
  /** If a copy could not be made.
   * @param clipboard The clipboard Object.
   * @param transferable A Transferable Object.
   */ 
  public void lostOwnership(Clipboard clipboard,
                            Transferable transferable)
  {
    System.out.println ("Lost Clipboard ownership");
  }
}
