/*
 * @(#)EditDelete.java 1.2 30.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;

/** An action for deleting contents of a cell.
 * 
 * @author sven.luzar
 * @version 2.0
 *
 */
public class EditDelete extends AbstractActionDefault {

 /**
  * Constructor for EditDelete.
  * @param graphpad This is a reference to the graphpad for this action,
  * and is sent to super().
  */
 public EditDelete(GPGraphpad graphpad) {
  super(graphpad);
 }

 /** Performs the delete action.
  * 
  * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
  * @param e The action to be performed.
  */
 public void actionPerformed(ActionEvent e) {
   
     Object[] cells = getCurrentGraph().getSelectionCells();
     if (cells != null) {
       cells =
         DefaultGraphModel
         .getDescendants(getCurrentGraph().getModel(), cells)
         .toArray();
       getCurrentGraph().getModel().remove(cells);
     }
 }
 
}
