/*
 * @(#)FileClose.java 1.2 30.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

import java.awt.event.ActionEvent;

/** The action for closing an open file.
 *
 * @author sven.luzar
 * @version 1.0
 *
 */
public class FileClose extends AbstractActionDefault {
  
  /**
   * Constructor for FileClose.
   * @param graphpad This is a reference to the graphpad for this action,
   * and is sent to super().
   */
  public FileClose(GPGraphpad graphpad) {
    super(graphpad);
  }
  
  /** Performs the action.
   * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
   * @param e The action to be performed.
   */
  public void actionPerformed(ActionEvent e) {
    if (graphpad.getCurrentDocument() == null)
      return;
    if (graphpad.getCurrentDocument().close(true))
    {
      graphpad.rulerSelected = false;
      graphpad.removeDocument(graphpad.getCurrentDocument());
    }
  }
  
}
