/*
 * @(#)FileExit.java 1.2 30.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

import java.awt.event.ActionEvent;
import javax.swing.JInternalFrame;


/**
 * Implementation of the exit command.
 *
 * @author sven.luzar
 * @version 3.0 TerpPresent.
 *
 */
public class FileExit extends AbstractActionDefault {
  
  /**
   * Constructor for FileExit.
   * @param graphpad This is a reference to the graphpad for this action,
   * and is sent to super().
   */
  public FileExit(GPGraphpad graphpad) {
    super(graphpad);
  }
  
  /** 
   * Presents a dialog to the user for each slide or TP Book that is open. The user can save and close, not
   * save and close or just cancel for each slide/TP Book.
   * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
   * @param e The action to be performed.
   */
  public void actionPerformed(ActionEvent e) 
	{
    int numNotClosed = 0 ; // How many frames were not closed.
    
    JInternalFrame[] frames = graphpad.getAllFrames();
    
    for (int i = 0; i < frames.length; i++) 
    {
      if (frames[i] instanceof GPInternalFrame) 
      {
        GPInternalFrame frame = (GPInternalFrame) frames[i];
        
        if (frame.getDocument().close(true)) // User chooses either Yes or No. If yes, a Save As dialog box was shown.
        {
          graphpad.rulerSelected = false;
          graphpad.removeGPInternalFrame(frame);
        } 	
        else
        	numNotClosed ++ ;
      }
    }
    
    if (numNotClosed == 0 )
    	System.exit (0) ;
  }
  
  /** Empty implementation.
   *  This Action should be available
   *  each time.
   */
  public void update() {
  };
}
