/*
 * @(#)FileLibraryOpen.java	1.2 29.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

import java.awt.event.ActionEvent;
import java.io.ObjectInputStream;

//import javax.swing.Icon;


/**
 * Action that opens a library from a file.
 * 
 * @author sven.luzar
 */
public class FileLibraryOpen extends AbstractActionFile {

	/** Constructor for FileLibraryOpen.
         * @param graphpad the graphpad to be edited */
	public FileLibraryOpen(GPGraphpad graphpad) {
		super(graphpad);
	}


        /** performs the library open action only if the file exists
         * @see com.jgraph.pad.actions.AbstractActionFile#openDialog(String,String,String) openDialog
         * @param e the event trigger
         */        
	public void actionPerformed(ActionEvent e) {
		String libraryExtension = Translator.getString("LibraryExtension");
  		String name = openDialog(
  			Translator.getString("openLabel"), 
  			libraryExtension, "JGraphpad Library (*."+libraryExtension+")");
		if (name != null) {
			try {
				ObjectInputStream in = createInputStream(name);
				getCurrentDocument().getLibraryPanel() .openLibrary(in.readObject());
				in.close();
				// Display Library
				getCurrentDocument().getSplitPane().resetToPreferredSizes();
			} catch (Exception ex) {
				graphpad.error(ex.toString());
			} finally {
				graphpad.repaint();
			}
		}
	}

}
