/*
 * @(#)FileLibraryRename.java	1.2 01.02.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;

import javax.swing.JOptionPane;


/** Renames a library.
 * @author sven.luzar
 * @version 2.0
 */
public class FileLibraryRename extends AbstractActionDefault {

	/** Constructs a JGraphpad from the graphpad of current document.
         * @param graphpad the graphpad to be edited
         */
	public FileLibraryRename(GPGraphpad graphpad) {
		super(graphpad);
	}

	/** Renames an existed library, new name must be legal.
         * @see java.awt.event.ActionListener#actionPerformed(ActionEvent) actionPerformed
         * @param e the event trigger
         */
	public void actionPerformed(ActionEvent e) {
		String name = getCurrentDocument().getLibraryPanel().getPanel().toString();
		name =
			JOptionPane.showInputDialog(graphpad.getFrame(), "Rename " + name);
		if (name != null && name.length() > 0) {
			getCurrentDocument().getLibraryPanel().getPanel().setName(name);
			graphpad.repaint();
		} else
			graphpad.error("Illegal name");
	}

}
