import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileReader;
//import java.io.FileWriter;
import java.io.BufferedReader;
//import java.util.Hashtable;

import javax.swing.JOptionPane;
//import javax.swing.filechooser.FileFilter;


/** FileRecent4 is a class that allows the application to shows a file chooser with the file filters from the file formats to select a file.
 * @author sven.luzar
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class FileRecent4 extends AbstractActionFile {

	/**
	 * Constructs a GPGraphpad for the current graphpad.
	 * @param graphpad the graphpad to be edited
	 * 
	 */
	public FileRecent4(GPGraphpad graphpad) {
		super(graphpad);
	}

	/** Shows a file chooser with the
	 *  file filters from the file formats
	 *  to select a file.
	 *
	 *  Furthermore, the method uses the selected
	 *  file format for the read process.
	 *
	 *  @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
	 *  @param e the event trigger
	 */
	public void actionPerformed(ActionEvent e) {
		String filename = null;

		File recentFiles;

		try
		{
			recentFiles = new File("RecentFiles.txt");
			BufferedReader recentFilesReader = new BufferedReader(new FileReader(recentFiles));

			filename = recentFilesReader.readLine().trim();
			filename = recentFilesReader.readLine().trim();
			filename = recentFilesReader.readLine().trim();
			filename = recentFilesReader.readLine().trim();

			recentFilesReader.close();

			if (filename != null) {
				// get all open files to test against
				GPDocument[] docs = graphpad.getAllDocuments();

				if (docs != null) {
					for (int i = 0; i < docs.length; i++) {
						String docname = docs[i].getFilename();
						// check if names are the same
						if (docname != null && filename.equals(docname)) {
							int r = JOptionPane.showConfirmDialog(
								graphpad,
								Translator.getString("FileAlreadyOpenWarning"),
								Translator.getString("Title"),
								JOptionPane.YES_NO_OPTION);
							// if YES then user wants to revert to previously saved version
							if (r == JOptionPane.YES_OPTION) {
								// close existing internal frame without saving
								graphpad.removeGPInternalFrame(docs[i].getInternalFrame());

								// open old version to revert to
								graphpad.addDocument(filename);
								return;
							}
							// doesn't want to revert and already open so cancel open
							else
								return;
						}
					}
				}
			}
			else return;

			graphpad.addDocument(filename);
		}
		catch(Exception myE)
		{
		}

		
	}

	/** Empty implementation.
	 *  This Action should be available
	 *  each time.
	 */
	public void update() {
	};

}
