/*
 * @(#)FileSaveAs.java	1.2 30.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;


/** Action opens a dialog to select the file.
 * After that, the action saves the current graph to
 * the selected file.
 * 
 * @author sven.luzar
 * @version 3.0 
 *
 */
public class FileSaveAs extends FileSave {

	/** Constructs a GPGraphpad for the current graphpad.
	 *  @param graphpad the graphpad to be edited
	 */
	public FileSaveAs(GPGraphpad graphpad) {
		super(graphpad);
	}

	/** Saves the graph to the selected file.
	 *  The graph must be in the corrected format and graph model.
	 *	@see comp.jgraph.pad.GraphModelProviderRegistry#getGraphModelFileFormat(File) getGraphFileFormat
	 *  @param e the event trigger
	 */
	public void actionPerformed(ActionEvent e) {
		getCurrentDocument().setFilename(null);
		super.actionPerformed(e);
	}
}
