/*
 * @(#)FormatAlignTop.java	1.2 31.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.JLabel;


/**
 * FormatAlignTop class allows the application to align the top part of the document.
 * @author sven.luzar
 * @version 1.0
 *
 */
public class FormatAlignTop extends AbstractActionDefault {

	/** Constructs a GPGraphpad for the current graphpad.
	 *  @param graphpad the graphpad to be edited
	 */
	public FormatAlignTop(GPGraphpad graphpad) {
		super(graphpad);
	}

	/** It first creates a map, and then sets top alignment on that map.
	 *  @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
	 *  @param e the event trigger
	 */
	public void actionPerformed(ActionEvent e) {
			Map map = GraphConstants.createMap();
			GraphConstants.setVerticalAlignment(map, JLabel.TOP);
			setSelectionAttributes(map);
	}

}
