/*
 * @(#)FormatFillNo.java	1.2 31.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;
import java.util.Map;

/**
 * Action that cleans the fill color for the 
 * selected cells.
 * 
 * @author sven.luzar
 * @version 1.0
 *
 */
public class FormatFillNo extends AbstractActionDefault {

	/**
	 * Constructor for FormatFillNo.
	 * This constructor is called from GPGraphPad.java.
     * @param graphpad the current state of the graph
	 */
	public FormatFillNo(GPGraphpad graphpad) {
		super(graphpad);
	}

	/** Perform the action of clearing the fill color of the selected cell.
	 * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
	 * @param e event trigger when menu-item is clicked or action is performed
	 */
	public void actionPerformed(ActionEvent e) {
		Map map = GraphConstants.createMap();
		GraphConstants.setOpaque(map, false);
		setSelectionAttributes(map);
	}

}
