/*
 * @(#)FormatShapeImage.java 1.2 29.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

import java.awt.event.ActionEvent;
import java.util.Map;


/**
 * Opens a dialog to load an image of the selected cells.
 * 
 * @author sven.luzar
 * @version 2.0 TerpPresent
 */
public class FormatShapeImage extends AbstractActionFile {

 /** Constructor for FormatShapeImage.
   * This constructor is called from GPGraphPad.java
   * @param graphpad Passes the current state of jGraphPad.
  */
 public FormatShapeImage(GPGraphpad graphpad) {
  super(graphpad);
 }

 /** Opens a dialog to load an image of the selected cells when
  * an action is initiated
  * @param e Called when menu-item is clicked or an Action is performed.
  * @throws ex Throws exception if image cannot be loaded.
  * @return void
  */
 public void actionPerformed(ActionEvent e)
 {
   // Should also offer a possibility to enter URL here
     String name = openDialog(Translator.getString("ImageDialog"), null, null);
   if (name != null) {
    try {
    	//(new Exception()).printStackTrace() ;
     ImageIconBean icon = new ImageIconBean(name);
     Map map = GraphConstants.createMap();
     GraphConstants.setIcon(map, icon);
     graphpad.getCurrentDocument().setSelectionAttributes(map);
     //graphpad.getCurrentGraph().repaint();
     
//     Toolkit toolkit = Toolkit.getDefaultToolkit();
//     ImageIcon icon = new ImageIcon(toolkit.getImage(name));
//     Map map = GraphConstants.createMap();
//     GraphConstants.setIcon(map, icon);
//     
//     graphpad.getCurrentDocument().setSelectionAttributes (map) ;
//     graphpad.getCurrentGraph().repaint();
    } 
    catch (Exception ex) 
		{
     graphpad.error(ex.toString());
     ex.printStackTrace();
    }
   }
 }

}
