/*
 * @(#)FormatSizeAuto.java 1.2 30.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;
import java.util.Map;

//import javax.swing.Icon;


/** Locks the connections of the selected cells, and automatically formats the size.
 * 
 * @author sven.luzar
 * @version 2.0 TerpPresent
 */
public class FormatSizeAuto extends AbstractActionDefault {

 /** Constructor for FormatSizeAuto.
         * This constructor is called from GPGraphPad.java
         * @param graphpad Passes the current state of jGraphPad.
         */
 public FormatSizeAuto(GPGraphpad graphpad) {
  super(graphpad);
 }



        /** Locks the connections of the selected cells, and automatically formats the size
         * when an action is initiated.
         * @param e called when a menu-item is clicked or an Action performed.
         * @return void
         */        
  public void actionPerformed(ActionEvent e) {
   Map map = GraphConstants.createMap();
   GraphConstants.setAutoSize(map, true);
   graphpad.getCurrentDocument().setSelectionAttributes(map);
  }
 

}
