/*
 * @(#)FormatTextFontStyleBold.java 1.2 30.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */


import java.awt.Font;
import java.awt.event.ActionEvent;


/** Sets the Font Style to bold
 *
 * @author sven.luzar
 */
public class FormatTextFontStyleBold extends AbstractActionDefault {

 /** Constructor for FormatTextFontStyleBold.
         * This constructor is called from GPGraphPad.java
         * @param graphpad - Passes the current state of jGraphPad
         */
 public FormatTextFontStyleBold(GPGraphpad graphpad) {
  super(graphpad);
 }

 /** Sets the Font Style to bold when an action is initiated
         * @param e - called when menu-item is clicked or Action performed
         */
 public void actionPerformed(ActionEvent e) {
   if( graphpad.fontStyle.equals( "italic" ) )  // make text bold and italics
   {
     graphpad.getCurrentDocument().setFontStyle(Font.BOLD+Font.ITALIC);
     graphpad.fontStyle = "bold_and_italic";
   }
   else if( !(graphpad.fontStyle.equals( "bold_and_italic" )) || graphpad.fontStyle.equals( "normal" ) )
   {  
     graphpad.getCurrentDocument() .setFontStyle(Font.BOLD);
     graphpad.fontStyle = "bold";
   }
 }

}
