/*
 * @(#)GPToolbox.java	2.0 1.2 11/11/02
 *
 * Copyright (C) 2001 Gaudenz Alder
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;

/** Class that handles the about dialog, extends JDialog
 *
 * @author TerpPresent
 * @version 2.0 TerpPresent
 */
public class GPAboutDialog extends JDialog {

    /** Default constructor for GPAboutDialog.
     * @param owner Frame type, the owner.
     * @param title String type, the title.
     * @param logo ImageIcon type, the logo.
     */    
	public GPAboutDialog(Frame owner, String title, ImageIcon logo) {
		super(owner, title, true);
		setSize(new Dimension(430, 270));

		JTabbedPane mainTabs = new JTabbedPane();
		JPanel aboutPanel = new JPanel();
		JPanel creditsPanel = new JPanel();
		JPanel presentPanel = new JPanel();
		mainTabs.addTab("About", aboutPanel);
		mainTabs.addTab("JGraphPad Credits", creditsPanel);
		mainTabs.addTab("TerpPresent Credits", presentPanel);
		getContentPane().add(mainTabs);
		setLocationRelativeTo(owner);
		setResizable(false);

		// Construct About Panel
		JLabel lab1 = new JLabel(logo);
		JLabel lab2 = new JLabel("TerpPresent");
		lab2.setFont(lab1.getFont().deriveFont(Font.PLAIN, 24));
		JLabel lab3 = new JLabel("Version " + Version.getVersion() );
		lab3.setFont(lab3.getFont().deriveFont(Font.PLAIN, 12));
		//JLabel lab4 =	new JLabel("Copyright (C) 2002 by Gaudenz Alder. All rights reserved.");
		//lab4.setFont(lab4.getFont().deriveFont(Font.PLAIN, 12));
		lab1.setBounds(10, 9, 20, 24);
		lab2.setBounds(40, 5, 360, 30);
		lab3.setBounds(40, 33, 360, 25);
		//lab4.setBounds(40, 190, 360, 25);
		JTextArea text = new JTextArea();
		text.setOpaque(false);
		text.setText(
			"TerpPresent is based of the freeware program JGraphPad.\n"
				+ "For inquiries of JGraphPad, send mail to info@jgraph.net\n\n"
				+ "JGraphpad is based on JGraph, an open source graph\n"
				+ "component for Swing. Visit the JGraph Home Page at\n"
				+ "http://www.jgraph.com for more information.\n\n");
		text.setBounds(40, 65, 355, 110);
		text.setFont(lab3.getFont());
		text.setEditable(false);
		aboutPanel.setLayout(null);
		aboutPanel.add(lab1);
		aboutPanel.add(lab2);
		aboutPanel.add(lab3);
		//aboutPanel.add(lab4);
		aboutPanel.add(text);

		// Construct Credits Panel
		JTextArea credits = new JTextArea();
		creditsPanel.setLayout(new BorderLayout());
		creditsPanel.add(new JScrollPane(credits), BorderLayout.CENTER);
		credits.setOpaque(false);
		credits.setText(
			"The following people and groups have made the JGraph\n"
				+ "Project possible:\n\n"
				+ "Thanks to Prof. Moira Norrie, Prof. Bernhard Plattner\n"
				+ "and Prof. Gerhard Trster for their support!\n\n"
				+ "Beat Signer from the Global Information Systems Group\n"
				+ "was instrumental in helping to get this project off the\n"
				+ "ground. He arranged that JGraph could be handed-in as a\n"
				+ "semester work.\n\n"
				+ "The new design was strongly influenced by Men Muheim's\n"
				+ "experiments with JGraph in another project. Thanks to Men\n"
				+ "for the redesign, and willingness to accept this work as\n"
				+ "a diploma thesis.\n\n"
				+ "Christophe Avare translated JGraphpad to French. Thomas\n"
				+ "Suter, Lars Gersmann, Markus Schmidt, Antonio Caliano,\n"
				+ "Martina Huber and Andri Krmer suggested new features or\n"
				+ "read the drafts of the documentation. Farrukh Najmi\n"
				+ "helped to put up the CVS repository, and Alex Shapiro\n"
				+ "implemented a cool automatic layout for JGraphpad\n"
				+ "(see www.touchgraph.com). Claudio Rosati and David\n"
				+ "Larsson submitted bug fixes and new features.\n\n"
				+ "The website and CVS resository are hosted by\n"
				+ "sourceforge.net (http://sourceforge.net/).\n\n"
				+ "Copyright (C) 2002 Gaudenz Alder. All rights reserved.\n");
		credits.setCaretPosition(0);
		credits.setEditable(false);

		//TerpPresent Credits Panel
		JTextArea credits2 = new JTextArea();
		presentPanel.setLayout(new BorderLayout());
		presentPanel.add(new JScrollPane(credits2), BorderLayout.CENTER);
		credits2.setOpaque(false);
		credits2.setText(
			"The following people and groups have made the TerpPresent\n"
				+ "Project possible:\n\n"
				+ "Version 3.0\n"
				+ "Pramit Mohapatra\n"
				+ "Jonathan Tyler Mowry\n"
				+ "Kim T Nguyen\n"
				+ "Vinh Xuan Nguyen\n"
				+ "Narimaan Pourahmadi\n" 
				+ "Basit Rauf\n"
				+ "Hariharan Sivaramakrishnan\n\n"
				+ "Version 2.0\n"
				+ "Amit Patel\n"
				+ "Rooshi Purohit\n"
				+ "Joshua Reichert\n"
				+ "Charles Song\n"
				+ "David Tang\n"
				+ "William Tung\n"
				+ "Joseph Wallner\n\n"
				+ "Version 1.0\n"
				+ "James Nixon\n"
				+ "Anthony Park\n"
				+ "Jason Pearlman\n"
				+ "Anupama Pillalamarri\n"
				+ "Sahil Rajan\n"
				+ "Anshuman Rastogi\n"
				+ "Justin Ray\n"
				+ "John Relunia\n"
				+ "Omer Shafi\n"
				);
		credits2.setCaretPosition(0);
		credits2.setEditable(false);

	}

	// Close on escape
        /** Closes on escape.
         * @return JRootPane type, returns an invisible rootpane.
         */        
	protected JRootPane createRootPane() {
		KeyStroke stroke = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
		JRootPane rootPane = new JRootPane();
		rootPane.registerKeyboardAction(new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				setVisible(false);
			}
		}, stroke, JComponent.WHEN_IN_FOCUSED_WINDOW);
		return rootPane;
	}

}