/*
 * @(#)GPTransferable.java	1.2 11/11/02
 *
 * Copyright (C) 2001 Gaudenz Alder
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

import java.awt.Rectangle;
import java.util.Map;


/** This extends GraphTransferable for allowing Transferring of GP* objects
 *
 * @author TerpPresent
 * @version 2.0 TerpPresent
 */
public class GPTransferable extends GraphTransferable {

    /** This is the title of what is being transfered.
     */    
	protected String text;

        /** This is the GPTransferable constructor.
         * @param text The title of what is being transfered
         * @param cells The cells transfered
         * @param cs The connectionset data
         * @param viewAttributes This is the map containing all of the transferring attributes
         * @param bounds These are the bounds containing what is being transfered
         */
	public GPTransferable(
		String text,
		Object[] cells,
		ConnectionSet cs,
		Map viewAttributes,
		Rectangle bounds) {
		super(cells, cs, viewAttributes, bounds);
		this.text = text;
	}

        /** This returns a boolean answering whether or not plain is supported.
         * @return true if text is not null
         */
	public boolean isPlainSupported() {
		return (text != null);
	}

        /** This gets the plain data.
         * @return Return the plain data
         */        
	public String getPlainData() {
		return text;
	}

}