import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Stroke;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;
//import java.util.Set;
import javax.swing.ImageIcon;
import javax.swing.UIManager;
import javax.swing.border.Border;


/**
 * This class that implements graph constants.
 *
 * Referenced classes of package com.jgraph.graph are
 * CellView, PortView, CellMapper, Edge and DefaultEdge.
 *
 * @author TerpPresent
 * @version 2.0 TerpPresent
 */

public class GraphConstants

{
    
    /**
     * An instance of Point.
     * Dummypoint.
     */
    public static final Point dummyPoint = new Point();
    
    /**
     * An instance of Font.
     * defaultfont
     */
    public static final Font defaultFont = UIManager.getFont("Tree.font");
    
    /**
     * An instance of String
     * availablekeys
     */
    public static String availableKeys[] = {
        "absolute", "autosize", "backgroundColor", "beginFill", "beginSize", "bendable", "border", "bordercolor", "bounds", "connectable",
        "dashPattern", "disconnectable", "editable", "endFill", "endsize", "fontName", "fontSize", "fontStyle", "foregroundColor", "horizontalAlignment",
        "verticalAlignment", "icon", "labelposition", "lineBegin", "linecolor", "lineEnd", "lineStyle", "linewidth", "moveable", "offset",
        "opaque", "points", "routing", "size", "sizeable", "value"
    };
    
    /**
     * An instance of float.
     * Default Font size.
     */
    public static final float DEFAULTFONTSIZE = 12F;
    
    /**
     * An instance of integer.
     * Default Font style.
     */
    public static final int DEFAULTFONTSTYLE = 0;
    
    /**
     * An instance of integer.
     * Default decoration size.
     */
    public static final int DEFAULTDECORATIONSIZE = 10;
    
    /**
     * An instance of integer.
     * 100 percent unit for relative positioning.
     */
    public static final int PERCENT = 1000;
    
    /**
     * An instance of float.
     * Global Stroke To Highlight Selection .
     */
    protected static float dash[] = {
        5F, 5F
    };
    
    /**
     * An instance of Stroke.
     */
    public static Stroke SELECTION_STROKE;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_NONE = 0;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_CLASSIC = 1;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_TECHNICAL = 2;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_FILLED_TECHNICAL = 3;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_SIMPLE = 4;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_CIRCLE = 5;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_FILLED_CIRCLE = 6;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_LINE = 7;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_DOUBLELINE = 8;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_DIAMOND = 9;
    
    /**
     * An instance of integer.
     */
    public static final int ARROW_FILLED_DIAMOND = 10;
    
    /**
     * An instance of integer.
     */
    public static final int STYLE_ORTHOGONAL = 11;
    
    /**
     * An instance of integer.
     */
    public static final int STYLE_QUADRATIC = 12;
    
    /**
     * An instance of integer.
     */
    public static final int STYLE_BEZIER = 13;
    
    /**
     * An instance of Edge.Routing.
     * A simple default Routing.
     */
    public static final Edge.Routing ROUTING_SIMPLE = new DefaultEdge.DefaultRouting();
    
    /**
     * An instance of String.
     * Key for the <code>replaceAttributes</code> attribute. This special
     * attribute contains a Boolean instance indicating whether a map of
     * attributes should replace the attributes of the receiving view.
     */
    public static final String REPLACEATTRIBUTES = "replaceAttributes";
    
    /**
     * An instance of String.
     * Key for the <code>removeAttributes</code> attribute. This special
     * attribute contains a list of attribute-keys which should be removed
     * at the receiving views.
     */
    public static final String REMOVEATTRIBUTES = "removeAttributes";
    
    /**
     * An instance of String.
     * Key for the <code>removeAll</code> attribute. This causes the
     * receivers attributes to be replaced by the the map that contains
     * this attribute.
     */
    public static final String REMOVEALL = "removeAll";
    
    /**
     * An instance of String.
     * Key for the <code>icon</code> attribute. Use instances of
     * ImageIcon as values for this key.
     */
    public static final String ICON = "icon";
    
    /**
     * An instance of String.
     * Key for the <code>fontname</code> attribute. Use instances of
     * String as values for this key.
     */
    public static final String FONTNAME = "fontName";
    
    /**
     * An instance of String.
     * Key for the <code>fontstyle</code> attribute. Use instances of
     * Integer as values for this key.
     */
    
    public static final String FONTSTYLE = "fontStyle";
    
    /**
     * An instance of String.
     * Key for the <code>opaque</code> attribute. Use instances of
     * Boolean as values for this key.
     */
    public static final String OPAQUE = "opaque";
    
    /**
     * An instance of String.
     * Key for the <code>border</code> attribute. Use instances of
     * Border as values for this key. Optionally, you can set the global
     * instance of LineBorder.
     */
    public static final String BORDER = "border";
    
    /**
     * An instance of String.
     * Key for the <code>linecolor</code> attribute. Use instances of
     * Color as values for this key.
     */
    public static final String LINECOLOR = "linecolor";
    
    /**
     * An instance of String.
     * Key for the <code>bordercolor</code> attribute. Use instances of
     * Color as values for this key.
     */
    public static final String BORDERCOLOR = "bordercolor";
    
    /**
     * An instance of String.
     * Key for the <code>linewidth</code> attribute. Use instances of
     * Float as values for this key.
     */
    public static final String LINEWIDTH = "linewidth";
    
    /**
     * An instance of String.
     * Key for the <code>foreground</code> attribute. Use instances of
     * Color as values for this key.
     */
    public static final String FOREGROUND = "foregroundColor";
    
    /**
     * An instance of String.
     * Key for the <code>background</code> attribute. Use instances of
     * Color as values for this key.
     */
    public static final String BACKGROUND = "backgroundColor";
    
    /**
     * An instance of String.
     * Key for the <code>verticalAlignment</code> attribute. Use instances of
     * Integer as values for this key. Constants defined in JLabel class.
     */
    public static final String VERTICAL_ALIGNMENT = "verticalAlignment";
    
    /**
     * An instance of String.
     * Key for the <code>horizontalAlignment</code> attribute. Use instances of
     * Integer as values for this key. Constants defined in JLabel class.
     */
    public static final String HORIZONTAL_ALIGNMENT = "horizontalAlignment";
    
    /**
     * An instance of String.
     * Key for the <code>verticalTextPosition</code> attribute. Use instances of
     * Integer as values for this key. Constants defined in JLabel class.
     */
    public static final String VERTICAL_TEXT_POSITION = "verticalTextPosition";
    
    /**
     * An instance of String.
     * Key for the <code>horizontalTextPosition</code> attribute. Use instances of
     * Integer as values for this key. Constants defined in JLabel class.
     */
    public static final String HORIZONTAL_TEXT_POSITION = "horizontalTextPosition";
    
    /**
     * An instance of String.
     * Key for the <code>dashPattern</code> attribute. Use instances of
     * float[] as values for this key.
     */
    public static final String DASHPATTERN = "dashPattern";
    
    /**
     * An instance of String.
     * Key for the <code>lineStyle</code> attribute. Use instances of
     * Integer as values for this key. Constants defined in this class.
     */
    public static final String LINESTYLE = "lineStyle";
    
    /**
     * An instance of String.
     * Key for the <code>start</code> attribute. Use instances of
     * Integer as values for this key. Constants defined in this class.
     */
    public static final String LINEBEGIN = "lineBegin";
    
    /**
     * An instance of String.
     * Key for the <code>start</code> attribute. Use instances of
     * Integer as values for this key. Constants defined in this class.
     */
    public static final String LINEEND = "lineEnd";
    
    /**
     * An instance of String.
     * Key for the <code>startsize</code> attribute. Use instances of
     * Integer as values for this key.
     */
    public static final String BEGINSIZE = "beginSize";
    
    /**
     * An instance of String.
     * Key for the <code>endsize</code> attribute. Use instances of
     * Integer as values for this key.
     */
    public static final String ENDSIZE = "endsize";
    
    /**
     * An instance of String.
     * Key for the <code>startsize</code> attribute. Use instances of
     * Integer as values for this key.
     */
    public static final String BEGINFILL = "beginFill";
    
    /**
     * An instance of String.
     * Key for the <code>endsize</code> attribute. Use instances of
     * Integer as values for this key.
     */
    public static final String ENDFILL = "endFill";
    
    /**
     * An instance of String.
     * Key for the <code>value</code> attribute. You can use any Object
     * as a value for this key.
     */
    public static final String VALUE = "value";
    
    /**
     * An instance of String.
     * Key for the <code>editable</code> attribute. Use instances of
     * Boolean as values for this key.
     */
    public static final String EDITABLE = "editable";
    
    /**
     * An instance of String.
     * Key for the <code>moveable</code> attribute. Use instances of
     * Boolean as values for this key.
     */
    public static final String MOVEABLE = "moveable";
    
    /**
     * An instance of String.
     * Key for the <code>sizeable</code> attribute. Use instances of
     * Boolean as values for this key.
     */
    public static final String SIZEABLE = "sizeable";
    
    /**
     * An instance of String.
     * Key for the <code>sizeable</code> attribute. Use instances of
     * Boolean as values for this key.
     */
    public static final String AUTOSIZE = "autosize";
    
    /**
     * An instance of String.
     * Key for the <code>sizeable</code> attribute. Use instances of
     * Boolean as values for this key.
     */
    public static final String BENDABLE = "bendable";
    
    /**
     * An instance of String.
     * Key for the <code>moveable</code> attribute. Use instances of
     * Boolean as values for this key.
     */
    public static final String CONNECTABLE = "connectable";
    
    /**
     * An instance of String.
     * Key for the <code>moveable</code> attribute. Use instances of
     * Boolean as values for this key.
     */
    public static final String DISCONNECTABLE = "disconnectable";
    
    /**
     * An instance of String.
     * Key for the <code>bounds</code> attribute. Use instances of
     * Rectangle as values for this key.
     */
    public static final String BOUNDS = "bounds";
    
    /**
     * An instance of String.
     * Key for the <code>points</code> attribute. Use instances of List
     * as values for this key. The list should contain Point instances.
     */
    public static final String POINTS = "points";
    
    /**
     * An instance of String.
     * Key for the <code>routing</code> attribute. Use instances of EdgeView.EdgeRouter
     * as values for this key. The list should contain Point instances.
     */
    public static final String ROUTING = "routing";
    
    /**
     * An instance of String.
     * Key for the <code>labelposition</code> attribute. Use instances of
     * Point as values for this key.
     */
    public static final String LABELPOSITION = "labelposition";
    
    /**
     * An instance of String.
     * Key for the <code>absolute</code> attribute. Use instances of
     * Boolean as values for this key.
     */
    public static final String ABSOLUTE = "absolute";
    
    /**
     * An instance of String.
     * Key for the <code>translate</code> attribute. Use instances of
     * Point as values for this key.
     */
    public static final String OFFSET = "offset";
    
    /**
     * An instance of String.
     * Key for the <code>resize</code> attribute. Use instances of
     * Dimension as values for this key.
     */
    public static final String SIZE = "size";
    
    /*
     * A public method
     */
    public GraphConstants() {
    }
    
    /**
     * Create attributes for Object.
     * @param obj A variable of Object data type.
     * @param obj1 A variable of Object data type.
     * @param obj2 A variable of Object data type.
     * @return A Map data type.
     * @see Object
     * @see Map
     */
    public static Map createAttributes(Object obj, Object obj1, Object obj2) {
        return createAttributes(new Object[] {
            obj
        }, new Object[] {
            obj1
        }, new Object[] {
            obj2
        });
    }
    
    /**
     * Create attributes for Object.
     * @param aobj A variable of Object data type.
     * @param obj A variable of Object data type.
     * @param obj1 A variable of Object data type.
     * @return A Map data type.
     * @see Object
     * @see Map
     */
    public static Map createAttributes(Object aobj[], Object obj, Object obj1) {
        return createAttributes(aobj, new Object[] {
            obj
        }, new Object[] {
            obj1
        });
    }
    
    /**
     * Create attributes for Object.
     * @param aobj A variable of Object data type.
     * @param aobj1 A variable of Object data type.
     * @param aobj2 A variable of Object data type.
     * @return A Map data type.
     * @see Object
     * @see Map
     */
    public static Map createAttributes(Object aobj[], Object aobj1[], Object aobj2[]) {
        if(aobj1 != null && aobj2 != null && aobj1.length != aobj2.length) {
            throw new IllegalArgumentException("Keys and values must have same length");
        }
        Hashtable hashtable = new Hashtable();
        for(int i = 0; i < aobj.length; i++) {
            if(aobj[i] != null) {
                Map map = createMap();
                for(int j = 0; j < aobj1.length; j++) {
                    if(aobj1[j] != null && aobj2[j] != null) {
                        map.put(aobj1[j], aobj2[j]);
                    }
                }
                
                hashtable.put(aobj[i], map);
            }
        }
        
        return hashtable;
    }
    
    /**
     * Create attributes for Object.
     * @param aobj A variable of Object data type.
     * @param cellmapper A variable of CellMapper data type.
     * @return A Map data type.
     * @see Object
     * @see CellMapper
     * @see Map
     */
    public static Map createAttributes(Object aobj[], CellMapper cellmapper) {
        Hashtable hashtable = new Hashtable();
        for(int i = 0; i < aobj.length; i++) {
            CellView cellview = null;
            Object obj = aobj[i];
            if(obj instanceof CellView) {
                cellview = (CellView)obj;
                obj = cellview.getCell();
            } else
                if(cellmapper != null) {
                    cellview = cellmapper.getMapping(obj, false);
                }
            if(cellview != null) {
                Map map = cloneMap(cellview.getAllAttributes());
                hashtable.put(obj, cloneMap(cellview.getAllAttributes()));
            }
        }
        
        return hashtable;
    }
    
    /**
     * Create map Object.
     * @return A Map data type.
     * @see Map
     */
    public static Map createMap() {
        return new Hashtable();
    }
    
    /**
     * Replace keys of Map Object.
     * @param map A variable of Map data type.
     * @param map1 A variable of Map data type.
     * @return A Map data type.
     * @see Map
     */
    public static Map replaceKeys(Map map, Map map1) {
        Hashtable hashtable = new Hashtable();
        for(Iterator iterator = map1.entrySet().iterator(); iterator.hasNext();) {
            java.util.Map.Entry entry = (java.util.Map.Entry)iterator.next();
            if(entry.getValue() instanceof Map) {
                Object obj = map.get(entry.getKey());
                if(obj != null) {
                    Map map2 = cloneMap((Map)entry.getValue());
                    hashtable.put(obj, map2);
                }
            }
        }
        
        return hashtable;
    }
    /**
     * Clones map Object.
     * @param map A variable of Map data type.
     * @return A Map data type.
     * @see Map
     */
    public static Map cloneMap(Map map) {
        Hashtable hashtable = new Hashtable(map);
        Rectangle rectangle = getBounds(hashtable);
        if(rectangle != null) {
            setBounds(hashtable, new Rectangle(rectangle));
        }
        java.util.List list = getPoints(hashtable);
        if(list != null) {
            setPoints(hashtable, clonePoints(list));
        }
        Point point = getLabelPosition(hashtable);
        if(point != null) {
            setLabelPosition(hashtable, new Point(point));
        }
        return hashtable;
    }
    
    /**
     * Clone Points of Object.
     * @param list A variable of List data type.
     * @return A List data type.
     * @see List
     */
    public static java.util.List clonePoints(java.util.List list) {
        ArrayList arraylist = new ArrayList();
        Object obj;
        for(Iterator iterator = list.iterator(); iterator.hasNext(); arraylist.add(obj)) {
            obj = iterator.next();
            if(obj instanceof PortView) {
                obj = ((PortView)obj).getLocation(null);
            } else
                if(obj instanceof Point) {
                    obj = new Point((Point)obj);
                }
        }
        
        return arraylist;
    }
    
    /**
     * Translates Object.
     * @param collection A variable of Collection data type.
     * @param i A variable of Object integer type.
     * @param j A variable of Object integer type.
     * @see Collection
     */
    public static void translate(Collection collection, int i, int j) {
        for(Iterator iterator = collection.iterator(); iterator.hasNext();) {
            Object obj = iterator.next();
            if(obj instanceof Map) {
                translate((Map)obj, i, j);
            }
        }
    }
    
    /**
     * Translates Object.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @param j A variable of integer data type.
     * @see Map
     */
    public static void translate(Map map, int i, int j) {
        if(isMoveable(map)) {
            Rectangle rectangle = getBounds(map);
            if(rectangle != null) {
                rectangle.translate(i, j);
            }
            java.util.List list = getPoints(map);
            if(list != null) {
                for(int k = 0; k < list.size(); k++) {
                    Object obj = list.get(k);
                    if(obj instanceof Point) {
                        ((Point)obj).translate(i, j);
                    }
                }
                
            }
        }
    }
    
    /**
     * Scales Map Object.
     * @param map A variable of Map data type.
     * @param d A variable of double data type.
     * @param d1 A variable of double data type.
     * @param point A variable of Point data type.
     * @see Map
     * @see Point
     */
    public static void scale(Map map, double d, double d1, Point point) {
        Rectangle rectangle = getBounds(map);
        if(rectangle != null) {
            Point point1 = new Point(rectangle.getLocation());
            point1.x = point.x + (int)Math.round((double)(point1.x - point.x) * d);
            point1.y = point.y + (int)Math.round((double)(point1.y - point.y) * d1);
            Point point2 = rectangle.getLocation();
            if(!point1.equals(point2)) {
                translate(map, point1.x - point2.x, point1.y - point2.y);
            }
            Dimension dimension = rectangle.getSize();
            Dimension dimension1 = new Dimension(Math.max(1, (int)Math.round((double)dimension.width * d)), Math.max(1, (int)Math.round((double)dimension.height * d1)));
            if(!dimension.equals(dimension1)) {
                rectangle.setSize(dimension1);
            }
        }
        java.util.List list = getPoints(map);
        if(list != null) {
            for(Iterator iterator = list.iterator(); iterator.hasNext();) {
                Object obj = iterator.next();
                if(obj instanceof Point) {
                    Point point3 = (Point)obj;
                    Point point4 = new Point(point3);
                    point4.x = point.x + (int)Math.round((double)(point4.x - point.x) * d);
                    point4.y = point.y + (int)Math.round((double)(point4.y - point.y) * d1);
                    if(!point4.equals(point3)) {
                        point3.translate(point4.x - point3.x, point4.y - point3.y);
                    }
                }
            }
            
        }
    }
    
    /**
     * Retrieves Map font attribute.
     * @param map A variable of Map data type.
     * @return A Font data type.
     * @see Map
     * @see Font
     */
    public static Font getFont(Map map) {
        String s = getFontName(map);
        int i = getFontStyle(map);
        float f = getFontSize(map);
        if(s != null) {
            return new Font(s, i, (int)f);
        } else {
            return defaultFont.deriveFont(i, f);
        }
    }
    
    /**
     * Setting map variable attribute with removeAttributes string.
     * @param map A variable of Map data type.
     * @param aobj A variable of Object data type.
     * @see Map
     * @see Object
     */
    public static final void setRemoveAttributes(Map map, Object aobj[]) {
        map.put("removeAttributes", ((Object) (aobj)));
    }
    
    /**
     * Retrieves Map attribute.
     * @param map A variable of Map data type.
     * @return An Object[] data type.
     * @see Map
     * @see Object
     */
    public static final Object[] getRemoveAttributes(Map map) {
        return (Object[])map.get("removeAttributes");
    }
    
    /**
     * A method that does some attribute check to apply on Map Object.
     * @param map A variable of Map data type.
     * @param map1 A variable of Map data type.
     * @return A Map data type.
     * @see Map
     */
    public static Map applyMap(Map map, Map map1) {
        Hashtable hashtable = new Hashtable();
        if(map != null) {
            if(isRemoveAll(map)) {
                hashtable.putAll(map1);
                map1.clear();
            }
            Object aobj[] = getRemoveAttributes(map);
            if(aobj != null) {
                for(int i = 0; i < aobj.length; i++) {
                    Object obj = map1.remove(aobj[i]);
                    if(obj != null) {
                        hashtable.put(aobj[i], obj);
                    }
                }
                
            }
            HashSet hashset = new HashSet();
            for(Iterator iterator = map.entrySet().iterator(); iterator.hasNext();) {
                java.util.Map.Entry entry = (java.util.Map.Entry)iterator.next();
                Object obj1 = entry.getKey();
                if(!obj1.equals("removeAll") && !obj1.equals("removeAttributes")) {
                    Object obj2 = map1.put(obj1, entry.getValue());
                    if(obj2 == null) {
                        hashset.add(obj1);
                    } else {
                        hashtable.put(obj1, obj2);
                    }
                }
            }
            
            if(!hashset.isEmpty()) {
                setRemoveAttributes(hashtable, hashset.toArray());
            }
        }
        return hashtable;
    }
    
    /**
     * Setting map variable attribute with icon string.
     * @param map A variable of Map data type.
     * @param imageicon A variable of ImageIcon data type.
     * @see Map
     * @see ImageIcon
     */
    public static final void setIcon(Map map, ImageIcon imageicon) {
        map.put("icon", imageicon);
    }
    
    /**
     * Retrieves Map icon attribute.
     * @param map A variable of Map data type.
     * @return A ImageIcon data type.
     * @see Map
     * @see ImageIcon
     */
    public static final ImageIcon getIcon(Map map) {
        return (ImageIcon)map.get("icon");
    }
    
    /**
     * Setting map variable attribute with fontName string.
     * @param map A variable of Map data type.
     * @param s A variable of string data type.
     * @see Map
     */
    public static final void setFontName(Map map, String s) {
        map.put("fontName", s);
    }
    
    /**
     * Retrieves Map fontaName attribute.
     * @param map A variable of Map data type.
     * @return A String data type.
     * @see Map
     */
    public static final String getFontName(Map map) {
        return (String)map.get("fontName");
    }
    
    /**
     * Setting map variable attribute with fontSize string.
     * @param map A variable of Map data type.
     * @param f A variable of float data type.
     * @see Map
     */
    public static final void setFontSize(Map map, float f) {
        map.put("fontSize", new Float(f));
    }
    
    /**
     * Retrieves Map fontSize attribute.
     * @param map A variable of Map data type.
     * @return A float data type.
     * @see Map
     */
    public static final float getFontSize(Map map) {
        Float float1 = (Float)map.get("fontSize");
        if(float1 != null) {
            return (float)float1.intValue();
        } else {
            return 12F;
        }
    }
    
    /**
     * Setting map variable attribute with fontStyle string.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @see Map
     */
    public static final void setFontStyle(Map map, int i) {
        map.put("fontStyle", new Integer(i));
    }
    
    /**
     * Retrieves Map fontStyle attribute.
     * @param map A variable of Map data type.
     * @return An integer data type.
     * @see Map
     */
    public static final int getFontStyle(Map map) {
        Integer integer = (Integer)map.get("fontStyle");
        if(integer != null) {
            return integer.intValue();
        } else {
            return 0;
        }
    }
    
    /**
     * Setting map variable attribute with opaque string.
     * @param map A variable of Map data type.
     * @param flag A variable of flag data type.
     * @see Map
     */
    public static final void setOpaque(Map map, boolean flag) {
        map.put("opaque", new Boolean(flag));
    }
    
    /**
     * Checks if Map Object is opaque.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final boolean isOpaque(Map map) {
        Boolean boolean1 = (Boolean)map.get("opaque");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return false;
        }
    }
    
    /**
     * Setting map variable attribute with border string.
     * @param map A variable of Map data type.
     * @param border A variable of Border data type.
     * @see Map
     * @see Border
     */
    public static final void setBorder(Map map, Border border) {
        map.put("border", border);
    }
    
    /**
     * Retrieves Map border attribute.
     * @param map A variable of Map data type.
     * @return A Border data type.
     * @see Map
     * @see Border
     */
    public static final Border getBorder(Map map) {
        return (Border)map.get("border");
    }
    
    /**
     * Setting map variable attribute with linecolor string.
     * @param map A variable of Map data type.
     * @param color A variable of Color data type.
     * @see Map
     * @see Color
     */
    public static final void setLineColor(Map map, Color color) {
        map.put("linecolor", color);
    }
    
    /**
     * Retrieves Map linecolor attribute.
     * @param map A variable of Map data type.
     * @return A Color data type.
     * @see Map
     * @see Color
     */
    public static final Color getLineColor(Map map) {
        return (Color)map.get("linecolor");
    }
    
    /**
     * Setting map variable attribute with bordercolor string.
     * @param map A variable of Map data type.
     * @param color A variable of Color data type.
     * @see Map
     * @see Color
     */
    public static final void setBorderColor(Map map, Color color) {
        map.put("bordercolor", color);
    }
    
    /**
     * Retrieves Map bordercolor attribute.
     * @param map A variable of Map data type.
     * @return A Color data type.
     * @see Map
     * @see Color
     */
    public static final Color getBorderColor(Map map) {
        return (Color)map.get("bordercolor");
    }
    
    /**
     * Setting map variable attribute with linewidth string.
     * @param map A variable of Map data type.
     * @param f A variable of float data type.
     * @see Map
     */
    public static final void setLineWidth(Map map, float f) {
        map.put("linewidth", new Float(f));
    }
    
    /**
     * Retrieves Map linewidth attribute.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final float getLineWidth(Map map) {
        Float float1 = (Float)map.get("linewidth");
        if(float1 != null) {
            return float1.floatValue();
        } else {
            return 1.0F;
        }
    }
    
    /**
     * Setting map variable attribute with foregroundcolor string.
     * @param map A variable of Map data type.
     * @param color A variable of Color data type.
     * @see Map
     * @see Color
     */
    public static final void setForeground(Map map, Color color) {
        map.put("foregroundColor", color);
    }
    
    /**
     * Retrieves Map foregroundColor attribute.
     * @param map A variable of Map data type.
     * @return A Color data type.
     * @see Map
     * @see Color
     */
    public static final Color getForeground(Map map) {
        return (Color)map.get("foregroundColor");
    }
    
    /**
     * Setting map variable attribute with backgroundColor string.
     * @param map A variable of Map data type.
     * @param color A variable of Color data type.
     * @see Map
     * @see Color
     */
    public static final void setBackground(Map map, Color color) {
        map.put("backgroundColor", color);
    }
    
    /**
     * Retrieves Map backgroundColor attribute.
     * @param map A variable of Map data type.
     * @return A Color data type.
     * @see Map
     * @see Color
     */
    public static final Color getBackground(Map map) {
        return (Color)map.get("backgroundColor");
    }
    
    /**
     * Setting map variable attribute with verticalAlignment string.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @see Map
     */
    public static final void setVerticalAlignment(Map map, int i) {
        map.put("verticalAlignment", new Integer(i));
    }
    
    /**
     * Retrieves Map verticalAlignment attribute.
     * @param map A variable of Map data type.
     * @return A integer data type.
     * @see Map
     */
    public static final int getVerticalAlignment(Map map) {
        Integer integer = (Integer)map.get("verticalAlignment");
        if(integer != null) {
            return integer.intValue();
        } else {
            return 0;
        }
    }
    
    /**
     * Setting map variable attribute with horizontalAlignment string.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @see Map
     */
    public static final void setHorizontalAlignment(Map map, int i) {
        map.put("horizontalAlignment", new Integer(i));
    }
    
    /**
     * Retrieves Map horizontalAlignment attribute.
     * @param map A variable of Map data type.
     * @return A integer data type.
     * @see Map
     */
    public static final int getHorizontalAlignment(Map map) {
        Integer integer = (Integer)map.get("horizontalAlignment");
        if(integer != null) {
            return integer.intValue();
        } else {
            return 0;
        }
    }
    
    /**
     * Setting map variable attribute with verticalTextPosition string.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @see Map
     */
    public static final void setVerticalTextPosition(Map map, int i) {
        map.put("verticalTextPosition", new Integer(i));
    }
    
    /**
     * Retrieves Map verticalTextPosition attribute.
     * @param map A variable of Map data type.
     * @return A integer data type.
     * @see Map
     */
    public static final int getVerticalTextPosition(Map map) {
        Integer integer = (Integer)map.get("verticalTextPosition");
        if(integer != null) {
            return integer.intValue();
        } else {
            return 3;
        }
    }
    
    /**
     * Setting map variable attribute with horizontalTextPosition string.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @see Map
     */
    public static final void setHorizontalTextPosition(Map map, int i) {
        map.put("horizontalTextPosition", new Integer(i));
    }
    
    /**
     * Retrieves Map horizontalTextPosition attribute.
     * @param map A variable of Map data type.
     * @return A integer data type.
     * @see Map
     */
    public static final int getHorizontalTextPosition(Map map) {
        Integer integer = (Integer)map.get("horizontalTextPosition");
        if(integer != null) {
            return integer.intValue();
        } else {
            return 0;
        }
    }
    
    /**
     * Setting map variable attribute with dashPattern string.
     * @param map A variable of Map data type.
     * @param af[] A variable of float data type.
     * @see Map
     */
    public static final void setDashPattern(Map map, float af[]) {
        map.put("dashPattern", af);
    }
    
    /**
     * Retrieves Map dashPattern attribute.
     * @param map A variable of Map data type.
     * @return A integer data type.
     * @see Map
     */
    public static final float[] getDashPattern(Map map) {
        return (float[])map.get("dashPattern");
    }
    
    /**
     * Setting map variable attribute with lineStyle string.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @see Map
     */
    public static final void setLineStyle(Map map, int i) {
        map.put("lineStyle", new Integer(i));
    }
    
    /**
     * Retrieves Map lineStyle attribute.
     * @param map A variable of Map data type.
     * @return A integer data type.
     * @see Map
     */
    public static final int getLineStyle(Map map) {
        Integer integer = (Integer)map.get("lineStyle");
        if(integer != null) {
            return integer.intValue();
        } else {
            return 11;
        }
    }
    
    /**
     * Setting map variable attribute with beginsize string.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @see Map
     */
    public static final void setBeginSize(Map map, int i) {
        map.put("beginSize", new Integer(i));
    }
    
    /**
     * Retrieves Map beginSize attribute.
     * @param map A variable of Map data type.
     * @return A integer data type.
     * @see Map
     */
    public static final int getBeginSize(Map map) {
        Integer integer = (Integer)map.get("beginSize");
        if(integer != null) {
            return integer.intValue();
        } else {
            return 10;
        }
    }
    
    /**
     * Setting map variable attribute with endsize string.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @see Map
     */
    public static final void setEndSize(Map map, int i) {
        map.put("endsize", new Integer(i));
    }
    
    /**
     * Retrieves Map beginsize attribute.
     * @param map A variable of Map data type.
     * @return A integer data type.
     * @see Map
     */
    public static final int getEndSize(Map map) {
        Integer integer = (Integer)map.get("endsize");
        if(integer != null) {
            return integer.intValue();
        } else {
            return 10;
        }
    }
    
    /**
     * Setting map variable attribute with LineBegin string.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @see Map
     */
    public static final void setLineBegin(Map map, int i) {
        map.put("lineBegin", new Integer(i));
    }
    
    /**
     * Retrieves Map lineBegin attribute.
     * @param map A variable of Map data type.
     * @return A integer data type.
     * @see Map
     */
    public static final int getLineBegin(Map map) {
        Integer integer = (Integer)map.get("lineBegin");
        if(integer != null) {
            return integer.intValue();
        } else {
            return 0;
        }
    }
    
    /**
     * Setting map variable attribute with LineEnd string.
     * @param map A variable of Map data type.
     * @param i A variable of integer data type.
     * @see Map
     */
    public static final void setLineEnd(Map map, int i) {
        map.put("lineEnd", new Integer(i));
    }
    
    /**
     * Retrieves Map lineEnd attribute.
     * @param map A variable of Map data type.
     * @return A integer data type.
     * @see Map
     */
    public static final int getLineEnd(Map map) {
        Integer integer = (Integer)map.get("lineEnd");
        if(integer != null) {
            return integer.intValue();
        } else {
            return 0;
        }
    }
    
    /**
     * Setting map variable attribute with value string.
     * @param map A variable of Map data type.
     * @param obj A variable of Object data type.
     * @see Map
     * @see Object
     */
    public static final void setValue(Map map, Object obj) {
        map.put("value", obj);
    }
    
    /**
     * Retrieves Map value attribute.
     * @param map A variable of Map data type.
     * @return An Object data type.
     * @see Map
     * @see Object
     */
    public static final Object getValue(Map map) {
        return map.get("value");
    }
    
    /**
     * Setting map variable attribute with labelposition string.
     * @param map A variable of Map data type.
     * @param point A variable of Point data type.
     * @see Map
     * @see Point
     */
    public static final void setLabelPosition(Map map, Point point) {
        map.put("labelposition", point);
    }
    
    /**
     * Retrieves Map labelposition attribute.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final Point getLabelPosition(Map map) {
        return (Point)map.get("labelposition");
    }
    
    /**
     * Setting map variable attribute with Editable string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     */
    public static final void setEditable(Map map, boolean flag) {
        map.put("editable", new Boolean(flag));
    }
    
    /**
     * Retrieves Map attribute and checks if it is editable.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final boolean isEditable(Map map) {
        Boolean boolean1 = (Boolean)map.get("editable");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return true;
        }
    }
    
    /**
     * Setting map variable attribute with moveable string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     */
    public static final void setMoveable(Map map, boolean flag) {
        map.put("moveable", new Boolean(flag));
    }
    
    /**
     * Retrieves Map attribute and checks if it is moveable.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final boolean isMoveable(Map map) {
        Boolean boolean1 = (Boolean)map.get("moveable");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return true;
        }
    }
    
    /**
     * Setting map variable attribute with sizeable string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     */
    public static final void setSizeable(Map map, boolean flag) {
        map.put("sizeable", new Boolean(flag));
    }
    
    /**
     * Retrieves Map attribute and checks if it is sizeable.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final boolean isSizeable(Map map) {
        Boolean boolean1 = (Boolean)map.get("sizeable");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return true;
        }
    }
    
    /**
     * Setting map variable attribute with autosize string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     */
    public static final void setAutoSize(Map map, boolean flag) {
        map.put("autosize", new Boolean(flag));
    }
    
    /**
     * Retrieves Map attribute and checks if it is autosize.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final boolean isAutoSize(Map map) {
        Boolean boolean1 = (Boolean)map.get("autosize");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return false;
        }
    }
    
    /**
     * Setting map variable attribute with bendable string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     * @see boolean
     */
    public static final void setBendable(Map map, boolean flag) {
        map.put("bendable", new Boolean(flag));
    }
    
    /**
     * Retrieves Map attribute and checks if it is bendable.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     * @see boolean
     */
    public static final boolean isBendable(Map map) {
        Boolean boolean1 = (Boolean)map.get("bendable");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return true;
        }
    }
    
    /**
     * Setting map variable attribute with connectable string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     */
    public static final void setConnectable(Map map, boolean flag) {
        map.put("connectable", new Boolean(flag));
    }
    
    /**
     * Retrieves Map attribute and checks if it is connectable.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final boolean isConnectable(Map map) {
        Boolean boolean1 = (Boolean)map.get("connectable");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return true;
        }
    }
    
    /**
     * Setting map variable attribute with disconnectable string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     */
    public static final void setDisconnectable(Map map, boolean flag) {
        map.put("disconnectable", new Boolean(flag));
    }
    
    /**
     * Retrieves Map attribute and checks if it is disconnectable.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     * @see boolean
     */
    public static final boolean isDisconnectable(Map map) {
        Boolean boolean1 = (Boolean)map.get("disconnectable");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return true;
        }
    }
    
    /**
     * Setting map variable attribute with points string.
     * @param map A variable of Map data type.
     * @param list A variable of List data type.
     * @see Map
     * @see List
     */
    public static final void setPoints(Map map, java.util.List list) {
        map.put("points", list);
    }
    
    /**
     * Retrieves Map points attribute.
     * @param map A variable of Map data type.
     * @return A List data type.
     * @see Map
     * @see List
     */
    public static final java.util.List getPoints(Map map) {
        return (java.util.List)map.get("points");
    }
    
    /**
     * Setting map variable attribute with routing string.
     * @param map A variable of Map data type.
     * @param Edge.Routing data type.
     * @see Map
     * @see Edge.Routing
     */
    public static final void setRouting(Map map, Edge.Routing routing) {
        map.put("routing", routing);
    }
    
    /**
     * Retrieves Map routing attribute.
     * @param map A variable of Map data type.
     * @return A Edge.Routing data type.
     * @see Map
     * @see Edge.Routing
     */
    public static final Edge.Routing getRouting(Map map) {
        return (Edge.Routing)map.get("routing");
    }
    
    /**
     * Setting map variable attribute with bounds string.
     * @param map A variable of Map data type.
     * @param rectangle A variable of Rectangle data type.
     * @see Map
     * @see Rectangle
     */
    public static final void setBounds(Map map, Rectangle rectangle) {
        map.put("bounds", rectangle);
    }
    
    /**
     * Retrieves Map bounds attribute.
     * @param map A variable of Map data type.
     * @return A Rectangle data type.
     * @see Map
     * @see Rectangle
     */
    public static final Rectangle getBounds(Map map) {
        return (Rectangle)map.get("bounds");
    }
    
    /**
     * Setting map variable attribute with size string.
     * @param map A variable of Map data type.
     * @param dimension A variable of Dimension data type.
     * @see Map
     * @see Dimension
     */
    public static final void setSize(Map map, Dimension dimension) {
        map.put("size", dimension);
    }
    
    /**
     * Retrieves Map size attribute.
     * @param map A variable of Map data type.
     * @return A Dimension data type.
     * @see Map
     * @see Dimension
     */
    public static final Dimension getSize(Map map) {
        return (Dimension)map.get("size");
    }
    
    /**
     * Setting map variable attribute with offset string.
     * @param map A variable of Map data type.
     * @param point A variable of Point data type.
     * @see Map
     * @see Point
     */
    public static final void setOffset(Map map, Point point) {
        map.put("offset", point);
    }
    
    /**
     * Retrieves Map offset attribute.
     * @param map A variable of Map data type.
     * @return A Point data type.
     * @see Map
     * @see Point
     */
    public static final Point getOffset(Map map) {
        return (Point)map.get("offset");
    }
    
    /**
     * Setting map variable attribute with beginFill string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     */
    public static final void setBeginFill(Map map, boolean flag) {
        map.put("beginFill", new Boolean(flag));
    }
    
    /**
     * Checking if Map attribute retrieved beginFill string.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final boolean isBeginFill(Map map) {
        Boolean boolean1 = (Boolean)map.get("beginFill");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return false;
        }
    }
    
    /**
     * Setting map variable attribute with endFill string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     */
    public static final void setEndFill(Map map, boolean flag) {
        map.put("endFill", new Boolean(flag));
    }
    
    /**
     * Checking if Map attribute retrieved endFill string.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final boolean isEndFill(Map map) {
        Boolean boolean1 = (Boolean)map.get("endFill");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return false;
        }
    }
    
    /**
     * Setting map variable attribute with absolute string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     */
    public static final void setAbsolute(Map map, boolean flag) {
        map.put("absolute", new Boolean(flag));
    }
    
    /**
     * Checking if Map attribute retrieved absolute string.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final boolean isAbsolute(Map map) {
        Boolean boolean1 = (Boolean)map.get("absolute");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return false;
        }
    }
    
    /**
     * Setting map variable attribute with removeAll string.
     * @param map A variable of Map data type.
     * @param flag A variable of boolean data type.
     * @see Map
     */
    public static final void setRemoveAll(Map map, boolean flag) {
        map.put("removeAll", new Boolean(flag));
    }
    
    /**
     * Checking if Map attribute retrieved removeAll string.
     * @param map A variable of Map data type.
     * @return A boolean data type.
     * @see Map
     */
    public static final boolean isRemoveAll(Map map) {
        Boolean boolean1 = (Boolean)map.get("removeAll");
        if(boolean1 != null) {
            return boolean1.booleanValue();
        } else {
            return false;
        }
    }
    
    static {
        SELECTION_STROKE = new BasicStroke(1.0F, 0, 0, 10F, dash, 0.0F);
    }
}
