import java.util.EventListener;

/**
 * All GraphModelListeners get fired when the graph itself is changed. This interface declares method graphChanged which
 * is implemented by every listener.
 *
 * @author TerpPresent
 * @version 2.0 TerpPresent
 *
 * @see com.jgraph.GraphModelEvent
 */
public interface GraphModelListener
    extends EventListener
{
    /**
     * This method gets called when the GraphModelEvent gets fired. A GraphModel event is fired when the graph is changed.
     *
     * @param graphmodelevent All the information about the event fired when a selection on the graph is changed.
     */
    public abstract void graphChanged(GraphModelEvent graphmodelevent);
}
