import java.util.EventListener;

/**
 * All GraphSelectionListeners get fired when any selection in the graph changes. This interface declares the
 * valueChanged method that needs to be implemented by all listeners.
 *
 * @author  Sven Luzar
 * @version 2.0 TerpPresent
 * @see com.jgraph.event.GraphSelectionEvent
 */
public interface GraphSelectionListener
    extends EventListener
{
    /**
     * This method is called when any selected component in the graph changes.
     *
     * @param graphselectionevent The information about the event that is fired when the graph is changed.
     */
    public abstract void valueChanged(GraphSelectionEvent graphselectionevent);
}
