/*
 * @(#)SelectAllClear.java 1.2 01.02.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;


/** Clears all the selection on any selected objects.
 * @author sven.luzar
 * @version 2.0 TerpPresent
 */
public class SelectAllClear extends AbstractActionDefault {

 /** Constructor for SelectAllClear.
         * This constructor is called from GPGraphPad.java
         * @param graphpad Passes the current state of jGraphPad.
         */
 public SelectAllClear(GPGraphpad graphpad) {
  super(graphpad);
 }

 /** Clears all the selection on any selected objects when an
         * action event is initiated.
         * @param e Called when a menu-item is clicked or an Action is performed.
         * @return void
         */
 public void actionPerformed(ActionEvent e) {
   getCurrentGraph().clearSelection();
 }

}
