/*
 * @(#)ShapeGroup.java 1.2 01.02.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;


/** Action that groups the current selection.
 * 
 * @author sven.luzar
 * @version 2.0 TerpPresent
 * @see com.jgraph.pad.actions.AbstractActionDefault
 */
public class ShapeGroup extends AbstractActionDefault {

 /** Constructor for ShapeGroup.
         * @param graphpad The parameter refers to the current graph.
         * @see com.jgraph.GPGraphpad
         */
 public ShapeGroup(GPGraphpad graphpad) {
  super(graphpad);
 }

 /** This function will group the selected objects.
         * @param e This parameter is called from selecting the corresponding menu item.
         * @see java.awt.event.ActionEvent
         */
 public void actionPerformed(ActionEvent e) {
  Object[] cells = getCurrentGraphLayoutCache().order(getCurrentGraph().getSelectionCells());
  if (cells != null && cells.length > 0) {
   DefaultGraphCell group = new DefaultGraphCell("Group");
   
   // FIX: for the next JGraph binary
    //ParentMap map = new ParentMap(getCurrentGraph().getModel());

   ParentMap map = new ParentMap();
   for (int i = 0; i < cells.length; i++)
    map.addEntry(cells[i], group);
   getCurrentGraph().getGraphLayoutCache().insert(
    new Object[] { group },
    null,
    null,
    map,
    null);
  }
 }

}
