/*
 * TPBookAddSlide.java
 *
 * Created on March 22, 2004, 5:39 PM
 */

import java.awt.event.*;

/** A action that will add a new empty slide to a document.
 *
 * @author TerpPresent
 * @author vxn
 * @version 3.0 TerpPresent
 */
public class TPBookAddSlide extends AbstractActionDefault {
    
    /**
     * Creates a new instance of TPBookAddSlide
     * @param graphpad A GPGraphpad object.
     */
    public TPBookAddSlide( GPGraphpad graphpad ) {
        super( graphpad );
        //setEnabled( false );
    }
    
    /**
     * Perform the action of adding a new empty slide to the document.
     * @param e An action event.
     * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        TPDocument tpDoc = (TPDocument)graphpad.getCurrentDocument();
        tpDoc.addNewSlide();
    }

    /** Empty implementation. 
    *  This Action should be available
    *  each time.
    */
    public void update(){};
    
}
