/*
 * TerpOfficeAppInterface.java
 *
 * Created on April 7, 2003, 4:26 PM
 */


import java.io.*;

/**
 *
 * This is the inteface to be implemented by all of the front ends of the TerpOfficeSuite. This provides TerpManager the
 * ability to safety close all the windows, without any loss of data. So, when an implementing class gets the close method,
 * it can save first. It also gives the ability to print a file without having to do it from the program, and the universal
 * way to open a file in the format of the members of TerpOffice.
 *
 * @author not attributable
 * @version 2.0 TerpPresent
 */
public interface TerpOfficeAppInterface {

  /**
   * Closes an instance of this class, i.e. closes the application.
   */
  public void close();

  /**
   * Opens a file in the current window.
   * @param file File that is to be opened.
   */
    public void launch(File file);

    /**
     * Determines whether the class is still alive or not.
     * @return True if the class is alive, false if it is not.
     */
    public boolean alive();

    /**
     * Public wrapper that calls the print method for the appropriate implementing class.
     * @param file The file that is to be printed.
     * @return True if the print was successful, false otherwise.
     */
    public boolean TerpPrint(File file);/* <--- New Addition */
}
