/*
 * @(#)Graphpad.java	1.2 11/11/02
 *
 * Copyright (C) 2001 Gaudenz Alder
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

import java.applet.Applet;
import java.awt.Color ;
import java.awt.BorderLayout;
import java.awt.* ;
import java.awt.Cursor;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JWindow;
import javax.swing.JFrame;

/** Sample application using the simple text editor component that
 * supports only one font.
 *
 * @author TerpPresent Group
 * @version 3.0 TerpPresent
 */
public class TerpPresent extends Applet {

  /** Method from com.jgraph.graph.JGraphpad
   * main
   * The main driver function.
   * @param args Argument list
   */
  public static void main(String[] args) {
    runPresent();
  }

  /**
   * True if the application is running, false otherwise.
   */
  public static boolean isRunning;

  /**
   * Constructor for this class. Sets isRunning to false.
   *
   */
  public TerpPresent(){ isRunning = false;}

  /**
   * The main method that runs TerpPresent.
   *
   */
  public static void runPresent(){
    isRunning = true;
    
    /* Show the splash screen */
    ImageIcon logoIcon = ImageLoader.getImageIcon("splash.gif");
    JWindow  splash= new JWindow();
 
    try 
    {
/*      JLabel lab = new JLabel(logoIcon) 
      {
      	public void paint(Graphics g) 
      	{
          super.paint(g);
        }
      };

      splash.getContentPane().add(lab, BorderLayout.CENTER);
      lab.setLayout(new BorderLayout());
      lab.setBorder(BorderFactory.createRaisedBevelBorder());

      splash.pack();
      Utilities.center(splash);
      splash.show();
*/
      GraphModelProviderRegistry.addGraphModelProvider(
 //       new DefaultGraphModelProvider());
            new TPGraphModelProvider() );

      // Open the graphpad application in a JFrame.
      GPGraphpad graphpad = new GPGraphpad();
      
      JFrame frame = new JFrame();
      frame.setIconImage(GPGraphpad.applicationIcon.getImage());
      frame.setTitle(GPGraphpad.appTitle);
      frame.getContentPane().add(graphpad);
      frame.addWindowListener(graphpad.new AppCloser());
      
      frame.pack();
      frame.show();
      
      frame.setDefaultCloseOperation (JFrame.DO_NOTHING_ON_CLOSE) ; // Ensure that the frame does not close if the user presses X
      
      frame.setSize(GPGraphpad.frameWidth, GPGraphpad.frameHeight); 
      frame.setLocation(20,20); 
      
      if (GPGraphpad.isFrameMaximize()) 
      {
        frame.setLocation(0, 0);
        frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
      }
      System.out.println("before WW="+frame.getWidth()+" HH="+frame.getHeight());
      graphpad.update() ; System.out.println("WW="+frame.getWidth()+" HH="+frame.getHeight());
      
      /* Open a slide by default */
      ((FileNew) graphpad.defaultActions[24]).actionPerformed (new java.awt.event.ActionEvent (new Object(), 0, "Default Slide")) ;

	  //added by Xun
	  //graphpad.getMarqueeHandler().getButtonRectangle().doClick();
	  //graphpad.drawLine();
	  //java.util.Vector tmp = graphpad.getContent();
	  //System.out.println("HAHA " + tmp.size() + " " + ((String)(tmp.elementAt(0))).length());
    } 
    catch (Exception e) 
    {
      e.printStackTrace();
      System.err.println(e.getMessage());
    } 
    finally 
    {
      isRunning = false;
      splash.dispose();
    }
  }


  /**
   * Initializes the applet.
   */

  public void init() {
    setLayout(new BorderLayout());
    setBackground(Color.white);
    JButton button = new JButton("Start");
    button.setIcon(GPGraphpad.applicationIcon);
    add(button, BorderLayout.CENTER);
    button.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
      }
    });
    button.setPreferredSize(getSize());
    button.revalidate();
    GPGraphpad graphpad = new GPGraphpad();
    //GPGraphpad.init();
  }
}
