/*
 * @(#) TextCell.java	1.0 11/2/03
 *
 * Copyright (C) 2001 Gaudenz Alder
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

/** This allows the formation of a cell specifically for text extending from the DefaultGraphCell.
 *
 * @author TerpPresent
 * @version 2.0 TerpPresent
 */
public class TextCell extends DefaultGraphCell {

	private boolean multiLined = true;

        /** TextCell constructor.
         */        
    public TextCell() {
      this(null);
    }

    /** TextCell constructor.
     * @param userObject this goes in the text cell
     */    
    public TextCell(Object userObject) {
      this(userObject, true);
    }

    /** TextCell constructor.
     * @param userObject this goes in the text cell
     * @param multiLined this tells whether the text cell will have multiple lines 
     */
    public TextCell(Object userObject, boolean multiLined) {
      super(userObject);
      this.multiLined = multiLined;
    }


    /** This checks to see if the text cell has multiple lines.
     * @return true if there are multiple lines of text 
     */
	public boolean isMultiLined() {
		return multiLined;
	}


}
