import java.awt.image.* ;
import java.util.Hashtable;
import javax.imageio.ImageIO;
import javax.swing.JFrame;
import java.beans.* ;
import java.io.*;
import java.util.zip.*;
import javax.swing.*;

/**	
 * 
 * Used to create a thumbnail image of the a TerpPresent tpb file. This uses
 * the default  .pad to .jpg converter included as a part of TerpPresent.
 * 
 * @author Hari Sivaramakrishnan, TerpPresent.
 * @version 3.0
 */

public class ThumbNail 
{ 
	public static void main ( String [] args ) {
		
		BufferedImage image ;
		
		try {
			image = getThumbNailImage ("c:\\Second.tpb" ) ;
			
			ImageIO.write(image, "jpg", new File ("c:\\second.jpg" ) ) ;
			
			//			image = getThumbNailImage("/Users/vxnguyen/one.pad" ) ;
			//			
			//			ImageIO.write(image, "jpg", new File ("/Users/vxnguyen/one.jpg" ) ) ;
			//			
			//			image = getThumbNailImage("/Users/vxnguyen/two.pad_xml" ) ;
			//			
			//			ImageIO.write(image, "jpg", new File ("/Users/vxnguyen/two.jpg" ) ) ;
			//			
		} catch ( Exception e ) {
			
			System.out.println ( e.toString () ) ;
			
		}
	}
	
	
	
	/**
	 * @author Hari
	 *
	 * To change the template for this generated type comment go to
	 * Window - Preferences - Java - Code Generation - Code and Comments
	 *	 Returns the specified file as a JPG image.
	 *	 	
	 * @param file The file that is to be converted to JPG.
	 * @return The.jpg image that represents the pad application.
	 * @throws Exception Throws an exception if there was an error in the conversion process.
	 */
	public static BufferedImage getThumbNailImage (String filename) throws Exception {
		
		GPGraphpad graphpad = new GPGraphpad () ;
		//JFrame frame = new JFrame () ;
		JWindow frame = new JWindow () ;
		frame.getContentPane().add ( graphpad ) ;
		
		GraphModelProviderRegistry.addGraphModelProvider( new TPGraphModelProvider());
		frame.setVisible(true) ;
		//graphpad.setVisible(true) ;
		
		BufferedImage image = addDocument ( graphpad, filename ) ;
		//frame.setVisible(true) ;
		frame.pack() ;
		frame.dispose() ;
		
		return image ;
		
	}
	
	
	/**
	 * @author Hari, Vinh Nguyen
	 *
	 * To change the template for this generated type comment go to
	 * Window - Preferences - Java - Code Generation - Code and Comment 
	 * Add document method opens the specified file in a newly created instance of TerpPresent.
	 * The pad application is then converted into JPG and the TerpPresent application is closed.
	 * 
	 * @param graphpad The TerpPresent application instance in which the pad file should be opened	
	 * @param file The file that has to be converted into JPG.
	 * @return An image object in the JPG format.
	 * @throws Exception Throws an exception if there was any problem in the conversion process.
	*/
	protected static BufferedImage addDocument (GPGraphpad graphpad, String filename) throws Exception 
	{
		GraphModelProvider graphModelProvider = 
			GraphModelProviderRegistry.getGraphModelProvider( filename );
		
		GraphModelFileFormat graphModelFileFormat =
			GraphModelProviderRegistry.getGraphModelFileFormat(filename);
	
		// error message if no file format found
		if (graphModelFileFormat == null) 
			throw new Exception ( "Could not generate a preview of the requested document" ) ;
	
		Object obj = null;
		if( graphModelFileFormat instanceof TPGraphModelFileFormatSerial ) {
			obj = readOneObjectSerial( filename );	
		} else if ( graphModelFileFormat instanceof TPGraphModelFileFormatXML ) {
			obj = readOneObjectXML( filename );
		} else {
			System.err.println( "This file format is currently not supported." );	
			throw new Exception( "Invalid GraphModelFileFormat used." );	
		}

		if( obj != null ) {
			GPGraph gpGraph = graphModelProvider.createCleanGraph(graphModelProvider.createCleanGraphModel()) ;

			gpGraph.setArchivedState( obj );
			
			// extract the read properties
			Hashtable props = graphModelFileFormat.getReadProperties(null);

			// try to read the graph model
			GraphModel model = null;

			model = graphModelFileFormat.read(filename, props, gpGraph);

			// add the new document with the new graph and the new model
			graphpad.addDocument(filename, graphModelProvider, gpGraph, model, null);
	
			graphpad.update();
			
			/* Convert the file into JPG */
			BufferedImage img = GPConverter.toImage(graphpad.getCurrentGraph());
			return img ;
		}
		
		return null ;
	}
	
	
	private static Object readOneObjectSerial( String filename ) throws Exception 
	{  
		ObjectInputStream objIn = null;
		
		try{
			
			InputStream inStream = new FileInputStream(filename);
			
			inStream = new GZIPInputStream( inStream );
			
			objIn = new ObjectInputStream( inStream );
			
		} catch( Exception e ) {
			
			InputStream inStream = new FileInputStream(filename);
			
			objIn = new ObjectInputStream( inStream );
			
		}
		
		int size = objIn.readInt();
		
		if( size > 0 ) {
			
			Object obj = objIn.readObject();
			
			objIn.close();
			
			return obj;
			
		}
		
		return null;
		
	}
	
	
	private static Object readOneObjectXML( String filename ) throws Exception {
		XMLDecoder in = null;
		try{
			
			InputStream inStream = new FileInputStream(filename);
			
			inStream = new GZIPInputStream( inStream );
			
			in = new XMLDecoder( new BufferedInputStream( inStream ) );
			
		} catch( Exception e ) {
			
			InputStream inStream = new FileInputStream(filename);
			
			in = new XMLDecoder( new BufferedInputStream( inStream ) );
			
		}
		
		
		
		int size = ((Integer)in.readObject()).intValue();
		
		if( size > 0 ) {
			
			Object obj = in.readObject();
			
			in.close();
			
			return obj;
			
		}
		
		return null;
		
	}	
}


