/*
 * @(#)ToolBoxIcon.java 1.2 05.02.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.Component;
import java.awt.event.ActionEvent;

import javax.swing.Icon;
import javax.swing.JToggleButton;


/** Implementation of the toolbox icon.
 * @author sven.luzar
 * @version 2.0 TerpPresent
 * @see com.jgraph.pad.actions.AbstractActionDefault
 */
public class ToolBoxIcon extends AbstractActionDefault {

 /** Constructor for ToolBoxIcon.
         * @param graphpad The parameter refers to the current graph.
         */
 public ToolBoxIcon(GPGraphpad graphpad) {
  super(graphpad);
 }

 /** Constructor for ToolBoxIcon.
         * @param graphpad Refers to the current graph.
         * @param name Specified string.
         */
 public ToolBoxIcon(GPGraphpad graphpad, String name) {
  super(graphpad, name);
 }

 /** Constructor for ToolBoxIcon.
         * @param graphpad Refers to the current graph.
         * @param name Specified string.
         * @param icon Specified icon.
         * @see com.jgraph.GPGraphpad
         */
 public ToolBoxIcon(GPGraphpad graphpad, String name, Icon icon) {
  super(graphpad, name, icon);
 }

 /** Retrieves the toolbox.
         * @param e This parameter is called from selecting the corresponding menu item.
         * @see java.awt.event.ActionEvent
         */
 public void actionPerformed(ActionEvent e) {
 }
 
 /** Retreives the selected tool from the toolbox.
         * @param actionCommand String that specified the action.
         * @return Returns the specified button.
         * @see java.awt.Component
         */
 protected Component getToolComponent(String actionCommand) {
  JToggleButton button = graphpad.getMarqueeHandler().getButtonImage() ;
  GPBarFactory.fillAbstractButton(
     button,
     getName(),
     actionCommand,
     false);
  return button;
 }
 /** Updates the button to show that it is selected.
         */
 public void update() {
  super.update();
  graphpad.getMarqueeHandler().getButtonImage().setEnabled(isEnabled());
 }

}
