/*
 * @(#)ToolBoxZoomArea.java 1.2 05.02.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.Component;
import java.awt.event.ActionEvent;

//import javax.swing.Icon;
import javax.swing.JToggleButton;



/** Implementation of zoom tool in toolbox.
 * @author sven.luzar
 * @version 2.0 TerpPresent
 * @see com.jgraph.pad.actions.AbstractActionDefault
 */
public class ToolBoxZoomArea extends AbstractActionDefault {

 /** Constructor for ToolBoxZoomArea.
         * @param graphpad The parameter refers to the current graph.
         * @see com.jgraph.GPGraphpad
         */
 public ToolBoxZoomArea(GPGraphpad graphpad) {
  super(graphpad);
 }

 /** This function will select the zoom tool.
         * @param e This parameter is called from selecting the corresponding menu item.
         * @see java.awt.event.ActionEvent
         */
 public void actionPerformed(ActionEvent e) {
 }

 /** Retrieves the selected tool.
         * @param actionCommand string that specifies the action.       
         * @return Returns the specified button.
         * @see java.awt.Component
         */
 protected Component getToolComponent(String actionCommand) {
  JToggleButton button = graphpad.getMarqueeHandler().getButtonZoomArea();
  GPBarFactory.fillAbstractButton(
     button,
     getName(),
     actionCommand,
     false);
  return button;
 }

 /** Updates the button that is selected.
         */
 public void update() {
  super.update();
  graphpad.getMarqueeHandler().getButtonZoomArea().setEnabled(isEnabled());
 }

}
