/*
 * @(#)ToolsSnapSize.java 1.2 01.02.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;

import javax.swing.JOptionPane;


/** Tool that snaps the selected object to a specified size.
 * @author sven.luzar
 * @version 2.0 TerpPresent
 * @see com.jgraph.pad.actions.AbstractActionDefault
 */
public class ToolsSnapSize extends AbstractActionDefault {

 /** Constructor for ToolsSnapSize.
         * @param graphpad The parameter refers to the current graph.
         * @see com.jgraph.GPGraphpad
         */
 public ToolsSnapSize(GPGraphpad graphpad) {
  super(graphpad);
 }

 /** This function will have the selected object snap to size.
         * @param e This parameter is called from selecting the corresponding menu item.
         * @exception NullPointerException when a null pointer rather than an object is used.
         * @exception Exception when an integer is not found in SizeDialog string.
         * @see java.awt.event.ActionEvent
         */
 public void actionPerformed(ActionEvent e) {
  try {
   int d =
    Integer.parseInt(
     JOptionPane.showInputDialog(
      Translator.getString("SizeDialog")));
   getCurrentGraph().setTolerance(d);
  } catch (NullPointerException npe) {
   // ignore
  } catch (Exception ex) {
   graphpad.error(ex.toString());
  }
 }

}
