/*
 * @(#)ViewRuler.java 1.2 02.02.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */


import java.awt.event.ActionEvent;

/** public class
 * @author sven.luzar
 * @version 1.0
 */
public class ViewRuler extends AbstractActionCheckBox {

    /** boolean variable
     */    
 protected boolean ruler = false;
 protected boolean isOpen = false;  // whether file is open, used only for the ruler option
 
 /** Constructor for ViewRuler.
         * @param graphpad The parameter refers to the current graph
         */
 public ViewRuler(GPGraphpad graphpad) {
  super(graphpad);
 }

 /** checks if the view ruler feature is selected
         * @param actionCommand - string that specifies the action
         * @return - returns true if selected, false otherwise
         */
 public boolean isSelected(String actionCommand) {
   if( isOpen )
     ruler = graphpad.rulerSelected;
   return ruler;
 }

 /** This function will make the rulers visible
         * @param e - This parameter is called from selecting the corresponding menu item
         */
 public void actionPerformed(ActionEvent e) {
   if( !isOpen )
     ruler = graphpad.rulerSelected;  
   ruler = !ruler;
   isOpen = true;
      
   if (ruler) {
   getCurrentDocument().getScrollPane() .setColumnHeaderView(getCurrentDocument().getColumnRule() );
   getCurrentDocument().getScrollPane() .setRowHeaderView(getCurrentDocument().getRowRule() );
  } else {
   getCurrentDocument().getScrollPane() .setColumnHeaderView(null);
   getCurrentDocument().getScrollPane() .setRowHeaderView(null);
  }
  graphpad.invalidate();
 }

}
