/*
 * @(#)ViewScaleZoomIn.java	1.2 30.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;

//import javax.swing.Icon;


/**
 * This class is used to zoom into the graph. More specifically, the scale doubles.
 *
 * @author sven.luzar
 * @version 2.0 TerpPresent.
 *
 */
public class ViewScaleZoomIn extends AbstractActionDefault {

  /**
   * Creates a ViewScaleZoomIn object for the specified graph.
   *
   * @param graphpad The graphpad on which the zoom operation has to be performed.
   */
  public ViewScaleZoomIn(GPGraphpad graphpad) {
    super(graphpad);
  }

  /**
   * This function actually zooms in and modifies the graph.
   *
   * @param e Describes the event associated with the zoom in. NOTE: THIS IS NEVER USED IN THE METHOD.
   */

    public void actionPerformed(ActionEvent e) {
      graphpad.getCurrentDocument() .setResizeAction(null);
      if (graphpad.getCurrentGraph() .getScale() < 8) {
        // "Zero Length String passed to TextLayout constructor"
        graphpad.getCurrentDocument() .
        setScale(graphpad.getCurrentGraph() .getScale() * 2);
        if (graphpad.getCurrentGraph() .getSelectionCell() != null)
          graphpad.getCurrentGraph() .scrollCellToVisible(graphpad.getCurrentGraph().getSelectionCell());
      }
    }

}
