/*
 * @(#)ViewScaleZoomOut.java	1.2 30.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;

/**
 * This class is used to zoom out of the graph. More specifically, it halves the current scale.
 *
 * @author sven.luzar
 * @version 2.0 TerpPresent.
 *
 */
public class ViewScaleZoomOut extends AbstractActionDefault {

  /**
   * Creates a new ViewScaleZoomOut object for the specified graph.
   *
   * @param graphpad The graph which we desire to zoom out.
   */
  public ViewScaleZoomOut(GPGraphpad graphpad) {
    super(graphpad);
  }

  /**
   * This function actually zooms out of the graph. It divides the scale into half of its original value.
   *
   * @param e The event associated with the zoom out action. NOTE: THIS IS NEVER USED IN THE METHOD.
   */
  public void actionPerformed(ActionEvent e) {
    getCurrentDocument().setResizeAction(null);
    getCurrentDocument().setScale(getCurrentGraph().getScale() / 2);
    if (getCurrentGraph().getSelectionCell() != null)
      getCurrentGraph().scrollCellToVisible(getCurrentGraph().getSelectionCell());
  }

}
