// Created by group on 3/31/03
/*
 * @(#)ViewSlideShow.java	1.2 02.02.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;

//import javax.swing.Icon;


/**
 * Class used to create a Slide Show in the application.
 *
 * @author TerpPresent
 * @version 2.0 TerpPresent.
 */
public class ViewSlideShow extends AbstractActionDefault {

  /**
   * Creates a new ViewSlideShow for the specified graphpad.
   *
   * @param graphpad The graphpad of which we want to create a slide show.
   */
    public ViewSlideShow(GPGraphpad graphpad) {
        super(graphpad);
    }

    /**
     * This function starts the slideshow.
     *
     * @param e - The event for staring the slide show. NOTE: THIS IS NEVER USED IN THE METHOD.
     */
    public void actionPerformed(ActionEvent e) {
        try
        {
            Runtime.getRuntime().exec("appletviewer slideshow.html");
        }
        catch(Exception exception)
        {
            System.out.println("Exception: " + exception);
        }
    }

}