/*
 * @(#)WindowLogConsole.java	1.2 30.01.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;


/** Sets the log console as visible.
 *
 * @author sven.luzar
 * @version 2.0 TerpPresent
 *
 */
public class WindowLogConsole extends AbstractActionDefault {

  /**
   * Creates a new WindowLogConsole for the specified graphpad.
   *
   * @param graphpad The graphpad for which we want to create a new log console.
   */
  public WindowLogConsole(GPGraphpad graphpad) {
    super(graphpad);
  }

  /**
   * Makes the log console visible.
   *
   * @param e - The event that is associated with menu item. NOTE: THIS IS NEVER USED IN THE METHOD.
   */
  public void actionPerformed(ActionEvent e) {
      graphpad.getLogConsole().setVisible(true);
  }

  /** Empty Implementation
   */
  public void update(){}
}
