/*
 * @(#)WindowMaximize.java	1.2 09.02.2003
 *
 * Copyright (C) 2003 sven.luzar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
import java.awt.event.ActionEvent;

//import javax.swing.Icon;
import javax.swing.JInternalFrame;



/**
 * Maximizes the main application window by maximizing all the JInternalFrames at the Desktop.
 *
 * @author sven.luzar
 * @version 2.0 TerpPresent.
 *
 */
public class WindowMaximize extends AbstractActionDefault {

  /**
   * Creates a new WindowMaximize object for the specified graph.
   *
   * @param graphpad The graphpad which needs to be maximized.
   */
  public WindowMaximize(GPGraphpad graphpad) {
    super(graphpad);
  }


  /**
   * Maximizes the graph and each JInternalFrame by calling the setMaximum(true) for each one of them.
   *
   * @param e - The event associated with maximizing the internal frames. NOTE: THIS IS NOT USED IN THIS METHOD.
   * @see javax.swing.JInternalFrame#setMaximum(boolean)
   */
  public void actionPerformed(ActionEvent e) {
    JInternalFrame[] ajif = graphpad.getAllFrames();

    for (int i = 0; i < ajif.length; i++) {
      try {
        ajif[i].setMaximum(true);
      } catch (java.beans.PropertyVetoException pvex) {

      }
    }
  }

}
